--IPV6
ALTER TABLE esia_device ADD COLUMN device_ip_address inet;
UPDATE esia_device SET device_ip_address='0.0.0.0'::inet + device_ip_addr;

--Issue #891 Pouvoir mettre une description sur des groupes de noeuds
ALTER TABLE esia_device_group ADD COLUMN device_group_description text;

-- Ajout de la colonne gérant le node tab
ALTER TABLE esia_device_advance_config_type ADD COLUMN device_config_type_nodetab character varying(150);
-- Création du nouveau groupe
INSERT INTO esia_groups(group_id, group_name, group_description)
VALUES (DEFAULT,'default_read_access','Acces par defaut en lecture');

INSERT INTO esia_group_device_access(access_group_id, access_device_id)
SELECT (SELECT group_id FROM esia_groups WHERE group_name= 'default_read_access' ),device_id
FROM esia_device;

INSERT INTO public.esia_privilege_grantedto(grant_group_id, grant_privilege_id, grant_acces)
VALUES ((SELECT group_id FROM esia_groups WHERE group_name= 'default_read_access' ), (SELECT privilege_id	FROM esia_privileges WHERE privilege_name='device_view'), 1);

--DAHBOARD
ALTER TABLE dashboard_widget_group ADD COLUMN widget_group_order integer DEFAULT 99;
ALTER TABLE dashboard_user_access ADD COLUMN board_user_access character varying(10) DEFAULT 'WRITE';
ALTER TABLE dashboard ADD COLUMN dashboard_link character varying(200);

ALTER TABLE dashboard_user_access DROP CONSTRAINT "dashboard_user_access_primaryKey";
ALTER TABLE dashboard_user_access ADD CONSTRAINT "dashboard_user_access_primaryKey" PRIMARY KEY (board_user_id, board_dashboard_id, board_user_access);

INSERT INTO dashboard_widget_group(widget_group_id, widget_group_name,widget_group_order) VALUES (DEFAULT,'FLAG',10);
INSERT INTO dashboard_widget_group(widget_group_id, widget_group_name,widget_group_order) VALUES (DEFAULT,'TOP',55);
UPDATE dashboard_user_access SET board_user_access='READ' WHERE board_user_share=true;

UPDATE dashboard_widget_group SET widget_group_order=20	WHERE widget_group_name='STATE';
UPDATE dashboard_widget_group SET widget_group_order=60	WHERE widget_group_name='PLAN';
UPDATE dashboard_widget_group SET widget_group_order=50	WHERE widget_group_name='APPLICATIVE';
UPDATE dashboard_widget_group SET widget_group_order=40	WHERE widget_group_name='SERVICE';
UPDATE dashboard_widget_group SET widget_group_order=30	WHERE widget_group_name='TAB';
UPDATE dashboard_view SET view_group_id=(select widget_group_id FROM dashboard_widget_group WHERE widget_group_name='PLAN') WHERE view_name='DASHBOARD_PLAN';
UPDATE dashboard_view SET view_file_path='/dashboard/view_4state.php?id=:widgetid' WHERE view_name IN ('DASHBOARD_SERV_STATE','DASHBOARD_NODE_STATE','DASHBOARD_PLUGIN_STATE','DASHBOARD_GROUPNODE_STATE');


DELETE FROM dashboard_widget WHERE widget_view_id=(SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_GOOGLEMAP');
DELETE FROM dashboard_widget WHERE widget_view_id=(SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_MAP_FLOOR');

DELETE FROM dashboard_view WHERE view_name='DASHBOARD_GOOGLEMAP';
DELETE FROM dashboard_view WHERE view_name='DASHBOARD_MAP_FLOOR';
UPDATE dashboard_view SET view_default_option = jsonb_set(view_default_option::jsonb, '{"type"}', '"value"'::jsonb) WHERE view_name = 'DASHBOARD_VIEW_VALUE';

--DAHBOARD nouvelle widget
INSERT INTO dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option,view_group_id)
    VALUES (DEFAULT,'DASHBOARD_TOP_NODE_ERROR','/dashboard/view_top_node_error.php?id=:widgetid',30, 100,300,
    '{"title":{"style":"text-align: center; font-size:15px; color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"},"interval":1,"limit":10,"type":"warning,critique"}',
			(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='TOP'));


INSERT INTO dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT,'DASHBOARD_FLAG_NODE_STATE','/dashboard/view_flag_state.php?id=:widgetid',30,100,300,
            '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"},"type":"abr","nodeid":[]}',
			(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='FLAG'));

INSERT INTO dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT,'DASHBOARD_FLAG_GROUPNODE_STATE','/dashboard/view_flag_state.php?id=:widgetid',30,100,300,
            '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"},"type":"abr","groupnodeid":[]}',
			(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='FLAG'));

INSERT INTO dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT,'DASHBOARD_FLAG_PLUGIN_STATE','/dashboard/view_flag_state.php?id=:widgetid',30,100,300,
            '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"},"type":"abr","pluginid":[]}',
			(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='FLAG'));

INSERT INTO dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT,'DASHBOARD_FLAG_SERVICE_STATE','/dashboard/view_flag_state.php?id=:widgetid',30,100,300,
            '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"},"type":"abr","service":[]}',
			(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='FLAG'));

INSERT INTO dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT,'DASHBOARD_GRAPHIC_SERV_GAUGE','/dashboard/view_graph.php?id=:widgetid',30,100,300,
            '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"service":"","type":"gauge"}',
			(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='SERVICE'));

INSERT INTO dashboard_view(view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option, view_group_id)
	VALUES (DEFAULT,'DASHBOARD_TAB_SERVICE','/dashboard/view_tab_service.php?id=:widgetid',30,100,300,
            '{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"},"type":"abr","service":[],"column":{"group":null,"message":"on","exec":"on"},"order":[]}',
			(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='TAB'));

            INSERT INTO dashboard_view(
                    view_id,
                    view_name,
                    view_file_path,
                    view_during,
                    view_default_height,
                    view_default_width,
                    view_default_option)
            VALUES(
                DEFAULT,
                'DASHBOARD_BACKUP_TABLE',
                '/dashboard/view_backup_table.php?id=:widgetid',
                30,
                100,
                300,
                '{"title":{"style":"text-align: center; font-size:15px; color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"}}');

-- Update les widget existante vers la widget de FLAG pour les types 'abre','token','rectangle'
UPDATE dashboard_widget
SET widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_FLAG_NODE_STATE')
WHERE widget_option->>'type' IN ('abre','token','rectangle')
    AND widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_NODE_STATE');

UPDATE dashboard_widget
SET widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_FLAG_GROUPNODE_STATE')
WHERE widget_option->>'type' IN ('abre','token','rectangle')
    AND widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_GROUPNODE_STATE');

UPDATE dashboard_widget
SET widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_FLAG_PLUGIN_STATE')
WHERE widget_option->>'type' IN ('abre','token','rectangle')
    AND widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_PLUGIN_STATE');

UPDATE dashboard_widget
SET widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_FLAG_SERVICE_STATE')
WHERE widget_option->>'type' IN ('abre','token','rectangle')
    AND widget_view_id = (SELECT view_id FROM dashboard_view WHERE view_name='DASHBOARD_SERV_STATE');

--Pour l'alerting
UPDATE esia_configuration
SET config_value  = regexp_replace(config_value,'(<tr>[^<]*<td>.*%node.group\s<\/td>[^<]*<\/tr>)',
'\1
<tr>
<td>Group description: </td><td>%node.groupdesc </td>
</tr>')
WHERE config_key='MAIL_FORMAT_MESSAGE' AND config_value NOT Like '%node.groupdesc%';

UPDATE esia_configuration
SET config_description  = regexp_replace(config_description,'(%node\.group.*)$',
'\1
%node.groupdesc => description du groupe du noeud','gm')
WHERE config_key='MAIL_FORMAT_MESSAGE' AND config_description NOT Like '%node.groupdesc%';

ALTER TABLE ONLY esia_web_plugin ADD CONSTRAINT web_name_unique UNIQUE (web_name);

CREATE TABLE esia_service_rra_file
(
    rra_file_id bigserial,
    rra_service_id bigint,
    rra_graph_num integer,
    rra_file_path character varying(300),
    CONSTRAINT "rra_file_primaryKey" PRIMARY KEY (rra_file_id),
    CONSTRAINT "rra_file_foreignKey_service_id" FOREIGN KEY (rra_service_id)
        REFERENCES esia_services (service_id) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
        NOT VALID
);
ALTER TABLE esia_service_rra_file OWNER to esia;

CREATE OR REPLACE FUNCTION public.trigger_delete_service()
    RETURNS trigger
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE NOT LEAKPROOF
AS $BODY$
BEGIN
    DELETE FROM esia_error_happen WHERE happen_service_id = OLD.service_id;
    DELETE FROM esia_service_response_program WHERE response_service_id = OLD.service_id;
    DELETE FROM esia_maintenance_configuration WHERE maintenance_conf_service_id = OLD.service_id;
    DELETE FROM esia_maintenance_planned WHERE planned_service_id = OLD.service_id;
	DELETE FROM esia_service_rra_file WHERE rra_service_id = OLD.service_id;
    RETURN OLD;
END;
$BODY$;

ALTER FUNCTION public.trigger_delete_service() OWNER TO esia;

