DROP FUNCTION get_availability(bigint, bigint, date, interval);
CREATE OR REPLACE FUNCTION get_availability(
    nodeid bigint,
    serviceid bigint,
    enddate timestamp without time zone,
    inter interval)
  RETURNS real AS
$BODY$
DECLARE 
	stardate timestamp without time zone;
BEGIN	
	--on calcul le nombre de seconde dans l'interval de temps
	SELECT (enddate - inter) INTO stardate;
	RETURN get_availability(nodeid,serviceid,stardate,enddate);
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION get_availability(bigint, bigint, timestamp without time zone, interval)
  OWNER TO esia;

CREATE OR REPLACE FUNCTION get_timeerror(
    IN nodeid bigint,
    IN serviceid bigint,
    IN stardate timestamp without time zone,
    IN enddate timestamp without time zone)
  RETURNS TABLE(type character varying, nbrsec double precision) AS $BODY$
BEGIN	
	SELECT date_part('epoch', enddate - stardate) INTO nbrsec;
	RETURN QUERY SELECT error_type, date_part('epoch',SUM(date_trunc('second',happen_time_acquitte) - date_trunc('second',happen_timestamp))) as sec_in_error FROM (
                --L'erreur de fin coupée
		SELECT error_type,happen_timestamp,enddate AS happen_time_acquitte
		FROM esia_error_happen 
		LEFT JOIN esia_errors ON error_id = happen_error_id
		WHERE happen_service_id = serviceid AND happen_device_id = nodeid
		AND happen_timestamp < enddate
		AND happen_time_acquitte > enddate
		UNION
                --Les erreurs qui ne sont pas coupées
		SELECT error_type,happen_timestamp,happen_time_acquitte 
		FROM esia_error_happen
		LEFT JOIN esia_errors ON error_id = happen_error_id
		WHERE happen_service_id = serviceid AND happen_device_id = nodeid
		AND happen_timestamp > stardate
		AND happen_time_acquitte < enddate
		UNION
                --L'erreur de début coupée
		SELECT error_type,stardate AS happen_timestamp,happen_time_acquitte 
		FROM esia_error_happen
		LEFT JOIN esia_errors ON error_id = happen_error_id
		WHERE happen_service_id = serviceid AND happen_device_id = nodeid
		AND happen_timestamp < stardate
		AND happen_time_acquitte > stardate
		UNION		
		-- nopresent
		SELECT 'nopresent' as error_type,stardate AS happen_timestamp,service_time_added AS happen_time_acquitte
		FROM esia_services
		WHERE service_id = serviceid
		AND service_time_added >  stardate
	) AS T2
	GROUP BY T2.error_type
	UNION
	SELECT 'total', date_part('epoch', enddate - stardate);
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION get_timeerror(bigint, bigint, timestamp without time zone, timestamp without time zone)
  OWNER TO esia;
